
class CFrameControlCtrl : public COleControl
{
	DECLARE_DYNCREATE(CFrameControlCtrl)

public:
	CFrameControlCtrl();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFrameControlCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

protected:
	~CFrameControlCtrl();

	DECLARE_OLECREATE_EX(CFrameControlCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CFrameControlCtrl)      // GetTypeInfo
	DECLARE_OLECTLTYPE(CFrameControlCtrl)		// Type name and misc status

	//{{AFX_MSG(CFrameControlCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//{{AFX_DISPATCH(CFrameControlCtrl)
	afx_msg void SendFrame(long bmph, long data, long size);
	afx_msg long Receive(long data1, long size1, long data2, long size2);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

	//{{AFX_EVENT(CFrameControlCtrl)
	void FireReadyToSend(long data, long size)
		{FireEvent(eventidReadyToSend,EVENT_PARAM(VTS_I4  VTS_I4), data, size);}
	void FireOnFrame(long bmph, long data, long size)
		{FireEvent(eventidOnFrame,EVENT_PARAM(VTS_I4  VTS_I4  VTS_I4), bmph, data, size);}
	void FireFrameLost()
		{FireEvent(eventidFrameLost,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

public:
	enum {
	//{{AFX_DISP_ID(CFrameControlCtrl)
	dispidSendFrame = 1L,
	dispidReceive = 2L,
	eventidReadyToSend = 1L,
	eventidOnFrame = 2L,
	eventidFrameLost = 3L,
	//}}AFX_DISP_ID
	};
   
   long copy(unsigned char* src, long size, unsigned char* &dst, long &max, int &vgl);
   long copy2(unsigned char* data1, long size1, unsigned char* data2, long size2, unsigned char *dst, long max, int &vgl);
   void readytosend(long data, long size, int &vgl);

   unsigned char *puffer, *pufferpos;
   long pufferlen;
};
